﻿namespace anbs_cp.Interfaces;

/// <summary>
/// Сериализация моделей, классов и других объектов
/// </summary>
public interface ISerializer
{
    /// <summary>
    /// Сериализация данных <paramref name="data"/> в строку.
    /// </summary>
    /// <typeparam name="T">Тип данных</typeparam>
    /// <param name="data">Данные</param>
    /// <returns>Сериализованные данные</returns>
    string Serialize<T> (T data);

    /// <summary>
    /// Десериализация данных из json-строки <paramref name="json"/>
    /// </summary>
    /// <typeparam name="T">Ожидаемый тип данных</typeparam>
    /// <param name="json">Сериализованные данные</param>
    /// <returns>Данные</returns>
    T? Deserialize<T> (string json);
}